#ifndef __NODE_DATA
#define __NODE_DATA

#include <iostream>
#include <algorithm>
#include "definitions.h"
class nodeData;

class nodeData {
public:
	nodeData(int nodeId, bool isLeaf, MDOUBLE probAcceleration, MDOUBLE probDeceleration);

	MDOUBLE getProbAcceleration() const {return _probAcceleration;}
	MDOUBLE getProbDeceleration() const {return _probDeceleration;}
	MDOUBLE getProbRateShift() const {return _probAcceleration+_probDeceleration;}
	MDOUBLE getProbNoRateShift() const {return 1.0-getProbRateShift();}
	bool isLeaf() const {return _isLeaf;}

	int operator<(const nodeData other) const;
	friend ostream& operator<<(ostream &out, const nodeData &data);
	int getNodeId() const {return _nodeId;}

private:
	int _nodeId;
	bool _isLeaf;
	MDOUBLE _probAcceleration;
	MDOUBLE _probDeceleration;
};

#endif // __NODE_DATA
