#ifndef __POS_DATA
#define __POS_DATA

#include "definitions.h"
#include "alphabet.h"
#include "nodeData.h"
#include <iostream>

class posData {
public:
	posData(int pos_in_MSA, int pos_in_RefSeq,int refSeqContent);
	~posData() {};
	void addNodeData(int nodeId,bool isLeaf, MDOUBLE probAcceleration,MDOUBLE probDeceleration);
	void clearNodesData();
	void addPosteriorProb(MDOUBLE posteriorProb);
	void clearPosteriorProbs();
	MDOUBLE getPostValRateShift() const {return _postValRateShift;}
	int getPosInMSA() const {return _pos_in_MSA;}
	int getPosInRefSeq() const {return _pos_in_RefSeq;}
	int getRefSeqContent() const {return _refSeqContent;}
	void sortNodesData(); // sort so that the highest P(shift)is first and the lowest is last.
	void printNodesData(ostream &out, int numNodes4pos,MDOUBLE nodes_cutoff=1.0) const; /// print numNodes4pos nodes with the highest which P(shift). (without leaves); by default don't print significance for any node (cutoff of 1)
	void printPostVal(ostream &out, const alphabet* alph,MDOUBLE cutoff);
	void calcPostValRateShift(int numRateShiftCategories); // assumes that _posteriorProbs is filled

private:
	int _pos_in_MSA;
	int _pos_in_RefSeq;
	int _refSeqContent;
	MDOUBLE _postValRateShift; // #### we don't need this member if we have _posteriorProbs
	Vdouble _posteriorProbs; // for each nu category
	vector<nodeData> _nodesData; // to be filled only if the pos is significant
};

#endif // __POS_DATA
