#ifndef ___RATESHIFT4SITE____H
#define ___RATESHIFT4SITE____H

#include "definitions.h"
#include <time.h>
#include "sequenceContainer.h"
#include "tree.h"
#include "stochasticProcess.h"
#include "logFile.h"
#include "raserOptions.h"
#include "mulAlphabet.h"
#include "computePijComponent.h"
#include "shiftNodes4site.h"
#include "distributionPlusCategory.h"
#include "raserModel.h"

class raser {

public:
	explicit raser(int argc, char* argv[]);
	virtual ~raser();
public:
	void run(int argc, char** argv);
	void printInfo(ostream& out);
	void fillOptionsParameters(int argc, char** argv);
	void optimizeParams();
	void getNodesPosteriorProbs4significantSites();
private:
	void initScAndTree();
	void estimateInitialBLs();
	void createTree();
	void computeNu4site(const int pos, posData& pos_data);
	void computePosteriorProbs();
//	void computePostValRateShift();
	void printResults();
	void printTreeWithNodeIdBPStyle(ostream &out) const;
	void recursivePrintTree(ostream &out,const tree::nodeP &myNode) const;
	void initPositionsData();
	void fillPij();
		
private:
	raserOptions* _pOptions;
	sequenceContainer* _baseSc; // for the base model
	sequenceContainer* _scSSRV; // for the SSRV model
	tree _t;
	raserModel* _raserModel;
	mulAlphabet * _alph; // for the SSRV model
	alphabet * _baseAlph; // for the base model
	sequence *_refSeq;
	vector<posData> _positionsData;
	computePijGam _pij;

};

#endif
