#ifndef SHIFT_NODES_4_SITES
#define SHIFT_NODES_4_SITES

#include "tree.h"
#include "sequenceContainer.h"
#include "stochasticProcess.h"
#include "distribution.h"
#include "suffStatComponent.h"
#include "computeUpAlg.h"
#include "computeDownAlg.h"
#include "treeIt.h"
#include "likelihoodComputationSPvec.h"
#include "posData.h"
#include "nodeData.h"

class shiftNodes4site
{
public:
	shiftNodes4site(const tree& et,
		const sequenceContainer& scSSRV,const sequenceContainer& baseSc,
		const vector <stochasticProcess*>& spVec,  // #### maybe should be vector<const stochasticProcess*> spVec
		const distribution* nuDistr, const sequence &refseq); 
	~shiftNodes4site() {}
	void computeSignificantBranches(vector<posData>& positionsData,MDOUBLE cutoff,computePijGam& pij, tree::nodeP myNode = NULL);

private:
	void init();
	void fillBranchesData(vector<posData>& positionsData,MDOUBLE cutoff,computePijGam& pij);
	//the following performs stochastic mapping for the inputted branches:
	void fillBranchesData(vector<posData>& positionsData,MDOUBLE cutoff,computePijGam& pij, vector <tree::nodeP> nodesToCalculate);
	doubleRep calcVal(int id, int nuCategor, computePijHom& nuCategorPij,int letter, int fatherLetter) const;
	void calcPosUpAndDown(const posData& positionData,computePijGam& pij);

private:
	const tree& _et;
	const sequenceContainer& _scSSRV;
	const sequenceContainer& _baseSc;
	vector <stochasticProcess*> _spVec;
	const distribution* _nuDistr;
	sequence _refSeq;
	suffStatGlobalGamPos _cup;
	suffStatGlobalGamPos _cdown;

};

#endif // SHIFT_NODES_4_SITES
